"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const styled_components_1 = require("styled-components");
const Input_1 = __importDefault(require("../../Input"));
const styles_1 = require("../styles");
const Column_1 = __importDefault(require("./Column"));
const Row = (props) => {
    const [controllers, setControllers] = (0, react_usestateref_1.default)(props?.controllers);
    const [indexes, setIndexes] = (0, react_usestateref_1.default)(props?.indexes);
    const [row, setRow] = (0, react_usestateref_1.default)(props?.row);
    let updateData = props?.update;
    let addData = props?.add;
    let deleteData = props?.delete;
    (0, react_1.useEffect)(() => {
        setControllers(props?.controllers);
    }, [props?.controllers, ...(props?.controllers || [])]);
    (0, react_1.useEffect)(() => {
        setIndexes(props?.indexes);
    }, [props?.indexes]);
    (0, react_1.useEffect)(() => {
        setRow(props?.row);
    }, [props?.row]);
    (0, react_1.useEffect)(() => {
        updateData = props?.update;
    }, [props?.update]);
    (0, react_1.useEffect)(() => {
        addData = props?.add;
    }, [props?.add]);
    (0, react_1.useEffect)(() => {
        deleteData = props?.delete;
    }, [props?.delete]);
    (0, react_1.useEffect)(() => {
        // console.log('Update Row',
        // deleteData,
        // addData,
        // updateData,
        // controllers,
        // indexes,
        // row);
        // console.log('Update Row', indexes);
    }, [deleteData, addData, updateData, controllers, indexes, row]);
    (0, react_1.useEffect)(() => {
        // console.log('Row Data Changed', row);
    }, [row, Object.values(row || {}), ...Object.values(row || {})]);
    (0, react_1.useEffect)(() => { }, [
        props?.indexes,
        props?.controllers,
        props?.row,
        props?.actions,
        props?.columnActions,
        props?.add,
        props?.delete,
        props?.update,
    ]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(styles_1.TR, { style: {
                cursor: 'pointer',
                alignItems: 'center',
                alignContent: 'center',
                alignSelf: 'center',
                alignmentBaseline: 'central',
                textAlign: 'center',
                verticalAlign: 'middle',
                ...props?.style,
            }, onKeyUp: (e) => props?.actions?.onKeyUp?.(e, indexes), onKeyDown: (e) => props?.actions?.onKeyDown?.(e, indexes), onInput: (e) => props?.actions?.onInput?.(e, indexes), onChange: (e) => props?.actions?.onChange?.(e, indexes), onClick: () => props?.actions?.onClick?.(indexes) }, controllers?.map?.((controller, index) => (react_1.default.createElement(styles_1.TH, { key: 'th' + index, style: {
                cursor: 'pointer',
                alignItems: 'center',
                alignContent: 'center',
                alignSelf: 'center',
                alignmentBaseline: 'central',
                verticalAlign: 'middle',
                ...controller?.style,
            } },
            react_1.default.createElement("div", { style: {
                    cursor: 'pointer',
                    alignItems: 'center',
                    alignContent: 'center',
                    alignSelf: 'center',
                    alignmentBaseline: 'central',
                    verticalAlign: 'middle',
                    justifyContent: 'center',
                    display: 'flex',
                    ...controller?.contentStyle,
                } },
                addData && controller?.hasAdd ? (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(Input_1.default, { style: {
                            float: 'left',
                            marginLeft: '5px',
                            marginRight: '5px',
                            marginBottom: '0px',
                            marginTop: '0px',
                            alignItems: 'center',
                            alignContent: 'center',
                            alignSelf: 'center',
                            alignmentBaseline: 'central',
                            verticalAlign: 'middle',
                            ...controller?.addStyle,
                        }, type: 'button', color: 'green', onClick: () => addData?.(row), value: '+', iconValue: true, ...(controller?.addProps || {}) }))) : (react_1.default.createElement(react_1.default.Fragment, null)),
                deleteData && controller?.hasDelete ? (react_1.default.createElement(Input_1.default, { style: {
                        float: 'left',
                        marginLeft: '5px',
                        marginRight: '5px',
                        marginBottom: '0px',
                        marginTop: '0px',
                        alignItems: 'center',
                        alignContent: 'center',
                        alignSelf: 'center',
                        alignmentBaseline: 'central',
                        verticalAlign: 'middle',
                        ...controller?.deleteStyle,
                    }, type: 'button', color: 'red', onClick: () => deleteData?.(indexes?.[0]), value: '−', iconValue: true, ...(controller?.deleteProps || {}) })) : (react_1.default.createElement(react_1.default.Fragment, null)),
                react_1.default.createElement(Column_1.default, { style: {
                        float: 'left',
                        cursor: 'pointer',
                        alignItems: 'center',
                        alignContent: 'center',
                        alignSelf: 'center',
                        alignmentBaseline: 'central',
                        verticalAlign: 'middle',
                        marginLeft: '5px',
                        marginRight: '5px',
                        marginBottom: '0px',
                        marginTop: '0px',
                        ...controller?.columnStyle,
                    }, controller: controller, indexes: [...(indexes || []), controller?.index], data: row?.[controller?.index || ''], update: updateData, actions: props?.columnActions }))))))));
};
exports.default = (0, styled_components_1.withTheme)(Row);
//# sourceMappingURL=index.js.map