"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const styled_components_1 = require("styled-components");
const Content_1 = require("../../Content");
const Text_1 = require("../../Text");
const Animation = (props) => {
    const [newProps, _setNewProps] = (0, react_1.useState)({
        ...props,
        Animation: undefined,
        Element: undefined,
        children: undefined,
    });
    const passProps = (props) => {
        return (props.children &&
            react_1.default.Children.map(props.children, (child) => {
                const clone = react_1.default.cloneElement(child, {
                    alt: props.alt || 'loading...',
                    anti: props.anti,
                });
                return clone;
            }));
    };
    (0, react_1.useEffect)(() => { }, [props, ...Object.values(props)]);
    return (react_1.default.createElement(Content_1.Wrapper, null,
        react_1.default.createElement(Content_1.Center, null,
            react_1.default.createElement(props.Animation, { ...newProps },
                passProps(props),
                react_1.default.createElement(react_1.default.Fragment, null,
                    props.progress && props.progress > 0 ? (react_1.default.createElement(Text_1.Text, { type: props.type, limitationType: props.limitationType },
                        props.progress,
                        "%")) : (react_1.default.createElement(react_1.default.Fragment, null)),
                    props.progress2 && props.progress2 > 0 ? (react_1.default.createElement(Text_1.Text, { type: props.type, limitationType: props.limitationType },
                        props.progress2,
                        "%")) : (react_1.default.createElement(react_1.default.Fragment, null)))))));
};
exports.default = (0, styled_components_1.withTheme)(Animation);
//# sourceMappingURL=index.js.map