"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const styles_1 = require("./styles");
const styled_components_1 = require("styled-components");
const Notification = (props) => {
    const { error, children, text, timer, setChildren, setError, setText } = (0, react_1.useContext)(props.context);
    const clear = () => {
        setError(false);
        setChildren([]);
        setText('');
    };
    (0, react_1.useEffect)(() => {
        let timeout;
        if (((text && text.length > 0) || (children && children.length > 0)) &&
            timer &&
            timer > 0) {
            timeout = setTimeout(clear, timer);
        }
        return () => {
            clearTimeout(timeout);
        };
    }, [error, children, text, timer]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(styles_1.NotificationWrapper, { onClick: clear, error: error }, text || children)));
};
exports.default = (0, styled_components_1.withTheme)(Notification);
//# sourceMappingURL=index.js.map