"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const styled_components_1 = require("styled-components");
const Input_1 = __importDefault(require("../../../Input"));
const Text_1 = require("../../../Text");
const Column = (props) => {
    const [controller, setController] = (0, react_usestateref_1.default)(props?.controller);
    const [indexes, setIndexes] = (0, react_usestateref_1.default)(props?.indexes);
    const [data, setData] = (0, react_usestateref_1.default)(props?.data);
    let updateData = props?.update;
    const [actions, setActions] = (0, react_usestateref_1.default)(props?.actions || controller?.actions || {});
    (0, react_1.useEffect)(() => {
        setController(props?.controller);
    }, [props?.controller, props?.controller?.actions]);
    (0, react_1.useEffect)(() => {
        setIndexes(props?.indexes);
    }, [props?.indexes]);
    (0, react_1.useEffect)(() => {
        setData(props?.data);
    }, [props?.data]);
    (0, react_1.useEffect)(() => {
        updateData = props?.update;
    }, [props?.update]);
    (0, react_1.useEffect)(() => {
        setActions(props?.actions || controller?.actions || {});
    }, [props?.actions, controller, controller?.actions]);
    (0, react_1.useEffect)(() => {
        // console.log('Update Column', indexes);
        // if (controller?.inputProps)
        // console.log('Update Column', controller?.inputProps);
    }, [controller, indexes, actions, data, updateData, controller?.inputProps]);
    return (react_1.default.createElement(react_1.default.Fragment, null, controller?.type === 'title' ? (react_1.default.createElement(Text_1.Text, { limitationType: controller?.titleLimitationType, type: controller?.titleType, style: { ...props?.style, ...controller?.titleStyle } }, controller?.name || controller?.index || '')) : updateData && controller?.hasEdit ? (react_1.default.createElement(Input_1.default, { style: { ...props?.style, ...controller?.inputStyle }, type: controller.type || 'text', name: controller?.name || controller?.index, value: data, setValue: (value) => {
            // console.log('Column setValue', value, indexes,updateData);
            updateData?.(indexes, value);
        }, defaultValue: data || controller?.defaultValue, "aria-label": controller?.ariaLabel || controller?.name || controller?.index, placeholder: controller?.placeholder || controller?.name || controller?.index, onKeyUp: (e) => {
            // console.log('Column onKeyUp', e, indexes);
            return actions?.onKeyUp?.(e, indexes);
        }, onKeyDown: (e) => actions?.onKeyDown?.(e, indexes), onInput: (e) => actions?.onInput?.(e, indexes), onChange: (e) => {
            // console.log('Column onChange', e, indexes);
            return actions?.onChange?.(e, indexes);
        }, onClick: () => actions?.onClick?.(indexes), ...(controller?.inputProps || {}) })) : controller?.hasAdd && !controller?.hasEdit && data == undefined ? (react_1.default.createElement(react_1.default.Fragment, null)) : (react_1.default.createElement(Text_1.Text, { limitationType: controller?.textLimitationType, type: controller?.textType, style: {
            ...(props?.style || {}),
            marginTop: '5px',
            marginBottom: '5px',
            ...controller?.textStyle,
        } }, data ||
        controller?.defaultValue ||
        controller?.name ||
        controller?.index))));
};
exports.default = (0, styled_components_1.withTheme)(Column);
//# sourceMappingURL=index.js.map