"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const styled_components_1 = require("styled-components");
const styles_1 = require("./styles");
const Row_1 = __importDefault(require("./Row"));
const Table = (props) => {
    const [controllers, setControllers] = (0, react_usestateref_1.default)(props?.controllers);
    const [newActions, setNewActions] = (0, react_usestateref_1.default)(props?.newActions);
    const [rowActions, setRowActions] = (0, react_usestateref_1.default)(props?.rowActions);
    const [newData, setNewData] = (0, react_usestateref_1.default)(props?.new);
    const [data, setData] = (0, react_usestateref_1.default)(props?.data);
    let updateData = props?.update;
    let updateNewData = props?.updateNew;
    let addData = props?.add;
    let deleteData = props?.delete;
    const [loading, setLoading] = (0, react_usestateref_1.default)(props?.loading);
    (0, react_1.useEffect)(() => {
        setControllers(props?.controllers);
    }, [props?.controllers, ...(props?.controllers || [])]);
    (0, react_1.useEffect)(() => {
        setNewActions(props?.newActions);
    }, [props?.newActions]);
    (0, react_1.useEffect)(() => {
        setRowActions(props?.rowActions);
    }, [props?.rowActions]);
    (0, react_1.useEffect)(() => {
        setNewData(props?.new);
    }, [props?.new]);
    (0, react_1.useEffect)(() => {
        updateNewData = props?.updateNew;
    }, [props?.updateNew]);
    (0, react_1.useEffect)(() => {
        setData(props?.data);
    }, [props?.data]);
    (0, react_1.useEffect)(() => {
        updateData = props?.update;
    }, [props?.update]);
    (0, react_1.useEffect)(() => {
        addData = props?.add;
    }, [props?.add]);
    (0, react_1.useEffect)(() => {
        deleteData = props?.delete;
    }, [props?.delete]);
    (0, react_1.useEffect)(() => {
        setLoading(props?.loading);
    }, [props?.loading]);
    (0, react_1.useEffect)(() => { }, [props?.Loading]);
    (0, react_1.useEffect)(() => {
        // console.log('Update Table', loading,
        // controllers,
        // newActions,
        // rowActions,
        // newData,
        // data,
        // updateData,
        // updateNewData,
        // addData,
        // deleteData);
    }, [
        loading,
        controllers,
        newActions,
        rowActions,
        newData,
        data,
        updateData,
        updateNewData,
        addData,
        deleteData,
    ]);
    return !loading ? (react_1.default.createElement(react_1.default.Fragment, null, controllers && controllers?.length > 0 ? (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { style: { width: '100%', maxWidth: '100%', ...props?.style } },
            react_1.default.createElement(styles_1.Table, { style: props?.tableStyle },
                react_1.default.createElement("thead", { style: {
                        width: '100%',
                        maxWidth: '100%',
                        paddingBottom: '20px',
                        ...props?.headerStyle,
                    } },
                    react_1.default.createElement(Row_1.default, { controllers: controllers?.map((controller) => {
                            const newController = { ...controller };
                            newController.type = 'title';
                            return newController;
                        }), style: { ...props?.headerRowStyle } })),
                react_1.default.createElement("tbody", { style: { width: '100%', ...props?.bodyStyle } }, data?.map?.((row, index) => {
                    // console.log('INIT Row', row, index);
                    return (react_1.default.createElement(Row_1.default, { key: 'row' + index, controllers: controllers, indexes: [index], row: row, update: updateData, actions: rowActions, delete: deleteData, style: { ...props?.rowStyle } }));
                })),
                react_1.default.createElement("tfoot", { style: {
                        width: '100%',
                        paddingBottom: '20px',
                        ...props?.footerStyle,
                    } }, addData ? (react_1.default.createElement(Row_1.default, { controllers: controllers, indexes: [], row: newData, update: updateNewData, add: addData, columnActions: newActions, style: { ...props?.addRowStyle } })) : (react_1.default.createElement(react_1.default.Fragment, null))))))) : (react_1.default.createElement(react_1.default.Fragment, null)))) : (props?.Loading || react_1.default.createElement(react_1.default.Fragment, null));
};
exports.default = (0, styled_components_1.withTheme)(Table);
//# sourceMappingURL=index.js.map